<?
/*
 -------------------------------------------------------------------------
 AllMyStats V1.56 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
French
Fichier stats_in.php  appel pour un accs public (ou non si $public = false;) au cumul des statistiques du mois en cours
Le dclenchement des mises  jour et la cration du fichier cache est effectue par les visiteurs 
suivant le rglage en minutes de l'interval entre 2 mises  jour (variable $time_update_cache)

Exemple:
$time_update_cache est rgl sur 5 (minutes)
Une mise  jour et une mise en cache a t effectue  12H00 : pour tous les visiteurs entre 12H00 et 12H05 c'est le fichier cache qui sera afffich
Le 1er visiteur aprs 12H05 declenchera un calcul et une mise en cache des stats du mois en cours.
Cette solution permet de ne pas recalculer  chaque visiteur tous les statistiques, et donc menage les ressources serveur.

Note
Ne pas oublier de mettre les mois couls en cache via l'admin, simplement visualiser le cumul, afin d'allger les calculs du mois en cours

-----------------------------------------
English
File stats_in.php called for a public (whether or not $ public = false;) the aggregate statistics of the current month
The trigger updates and creating the cache file is made by the visitors
according to the setup in minutes from the interval between 2 updates ($ variable time_update_cache)

Example:
$time_update_cache is set to 5 (minutes)
An update and caching has been completed 12H00: for all visitors between 12:00 and 12:05 is the cache file that will afffich
The 1st visitor after 12:05 will trigger a load and a caching stats from this month.
This solution can not be recalculated each visitor all the statistics, and thus spare the server resources.
*/

//######################################################## Configuration #######################################################################
	
	$public = false; 	//true pour accs public si false on ne peut y accder seulement si l'on est connect  l'admin
						//true for public access if false it can be accessed only if it is connected to Admin

	$html_body = false; //Si nouvelle page --> true - Si intgr dans une page existante --> false
						//If new page --> true - If integrated into an existing page --> false
//------------------------------------------------------------------------------
	$txt_title = 'style="font-family: Verdana, Arial, sans-serif; font-weight: bold; font-size: 12px"';
	$txt_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 11px"';
	$td_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 10px"';
	$th_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 10px"';
	$table_border = 'style="border: 0px solid black; background-color: #000000; width: 570px"';
	$table_frame = 'style="border: 0px solid #000000; background-color: #99CCFF; width: 100%"';
	$table_data = 'style="background-color: #FAFAFA; width: 100%"';
	$table_title = 'style="font-family: Verdana, Arial, sans-serif; font-size: 14px; font-weight: bold; text-align:center; vertical-align:middle"';
	$page_view = 'style="color: #2000FF; font-family: Verdana, Arial, sans-serif; font-size: 10px; font-style: normal"';
	$style_visits = 'style="color: #8F0080; font-family: Verdana, Arial, sans-serif; font-size: 10px; font-style: normal"';
//------------------------------------------------------------------------------

/*
Si ce fichier est appel  partir d'une ou d'autres pages  l'aide de 
require_once('allmystats/stats_in.php');  // Chemin vers allmystats stats_in.php
il est possible de dplacer ces variables juste avant le require, ce qui permet suivant les pages qui appellent stats_in.php d'afficher les tableaux dsirs
Dans ce cas commenter les lignes ci-dessous et voir les fichiers exemples dans /exemple_stats_in

If this file is called from one or more pages using
require_once ('allmystats / stats_in.php') / / Path to allmystats stats_in.php
it is possible to move these variables just before the require, which allows the following pages that call stats_in.php display tables desired
In this case the comment line below and see the example files in / exemple_stats_in

*/
//-------------------------------------------------------------------------------

// Si le stats_in.php est appel directement par un simple lien vers stats_in.php, dcommenter les lignes ci-dessous ( supprimer /* et */ )
// If the stats_in.php is called directly by a simple link to stats_in.php, uncomment the line below (remove / * and * /)
/*
$html_body = true; 					// Si nouvelle page --> true - Si intgr dans une page existante --> false - If new page --> true. If integrated into an existing page --> false
$display_graph_by_day = true;		// true ou false , affichage graphique: visiteurs & pages visites/jour. Graphic display: visitors & page views / day
$display_keywords = true; 			// true ou false , affichage du tableau des mots cls (du mois en cours). Display tabbleau keywords (monthly)
$display_keywords_by_day = false;	// true ou false , affichage du tableau des mots cls du jour (du jour). Display tabbleau keywords (daily)
$display_top_keywords = 1000;		// Actif si $display_keywords ou $display_keywords_by_day = true. On if $display_keywords or $ display_keywords_by_day = true (max display keywords by referer)
$display_page_view = true; 			// true ou false , affichage du tableau pages visites. true or false, table view page views
$display_org_geo = true; 			// true ou false , affichage du tableau origine gographique des visiteurs. Display tabbleau geographic origin of visitors
$display_operating_system = true;	// true ou false , affichage du tableau OS(Operating System) des visiteurs. table view OS (Operating System) of visitors
$display_browsers = true;			// true ou false , affichage du tabbleau Navigateurs utiliss par les visiteurs. view table Browsers used by visitors
$display_bots = true;				// true ou false , affichage du tabbleau des des visites robots. view table of visits robots.
$display_bad_user_agent = false; 	// Si true ne sera affich que si au moins 1 bad user agent est dtect. If true would be displayed only if at least 1 bad user agent is detected
$time_update_cache = 15;			// Dlai en minutes entre 2 mises  jour du fichier cache du mois en cours. Permet de ne pas charger les ressources serveur
									// Delay in minutes between 2 updates the cache file of the current month. Lets not load the server resources
*/

//------------------------------------------------------------------------------
//#################################################################################################################################################

include_once('application_top.php');
require ("config_allmystats.php");
require('includes/mysql_tables.php');
require ("includes/languages/".$langue."/main.php");

require_once('includes/functions.php');
include_once('version.php');

if(!$display_top_keywords) { $display_top_keywords = 1000; }

mysql_connect($mysql_host,$mysql_login,$mysql_pass);
mysql_select_db($mysql_dbnom);
$mois = trim(date('m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))))); 


		//#####################################################################################################
		$mois_Visualise = $mois;
		$Mois_Annee = explode("/", $mois_Visualise);
		$format_date_file_name = $Mois_Annee[1].'-'.$Mois_Annee[0];

		//---------- Construction du suffixe fichier cache -------------------
		$suffixe = "";
		if ($display_graph_by_day) {
		$suffixe .= "gd";
		}
		if ($display_keywords) {
		$suffixe .= "kw";
		}
		if ($display_keywords_by_day) {
		$suffixe .= "kwd";
		}
		if ($display_page_view) {
		$suffixe .= "pv";
		}
		if ($display_org_geo) {
		$suffixe .= "ge";
		}
		if ($display_operating_system) {
		$suffixe .= "os";
		}
		if ($display_browsers) {
		$suffixe .= "na";
		}
		if ($display_bots) {
		$suffixe .= "ro";
		}
		
		// Sinon fait: //Warning: filemtime() [function.filemtime]: SAFE MODE Restriction in effect. ? Pour $path_allmystats_abs
		$Racine_abs = str_replace($_SERVER['PHP_SELF'],"",$_SERVER['SCRIPT_FILENAME']);
		$path_allmystats = $Racine_abs.$path_allmystats_abs;

		$cache_mois_in = "";

	if( ($user_login!=$_SESSION['userlogin'] || $passwd!=$_SESSION['userpass']) && $public==false)	{
		echo "<br /><br /><center><strong>Vous n'tes pas autoris  visiter cette page</strong></center><br />";
		exit;
	} else {
		if ( date('YmdHi') > date("YmdHi", @filemtime($path_allmystats."cache/stats_".$site."_".$format_date_file_name."-".$suffixe.".php")) + $time_update_cache || isset($archive_encours) ){
			//echo "<br /><strong>Todo mise en cache</strong><br />";
			$action_cache_mois_in = true;
			msg_temporaire('<p align="center" id="cache"><strong><big><font color="#FF0000">Opration en cours, veuillez patienter...</font></big></strong></p>');
			echo '<div align="center" '.$txt_title.'>Statistiques site: '.$site." - Mois: ".$mois_Visualise.'</div><div align="center">Dernire mise  jour: '.date('d/m/Y  H:i').'</div>';
		} else {
			//echo "<br /><strong>Pas de mise en cache  faire</strong><br />";
			$action_cache_mois_in = false;
			echo "<center>Dernire mise  jour: ".date("d/m/Y  H:i", filemtime($path_allmystats."cache/stats_".$site."_".$format_date_file_name."-".$suffixe.".php"))."</center>" ; //Date de drnire mise  jour du fichier
			include_once($path_allmystats."cache/stats_".$site."_".$format_date_file_name."-".$suffixe.".php");
		}
	}
		//-------------------------------------------------------------------
		//############################################################# End init ###########################################

if ($action_cache_mois_in) {

				//--------- Pour viter de lancer le script par plusieurs visiteurs ------------
				 $nbSlashes = substr_count($_SERVER['SCRIPT_NAME'], '/'); // on compte le nombre total de slashes contenu dans le lien relatif du fichier courant
				 $nbSlashes --; // on ne compte pas le slash de la racine (plac au dbut du lien relatif)
				 $remontee = ''; // on initialise la remonte dans l'arborescence
				 for($i = 0; $i < $nbSlashes; $i++)
				 {
					 $remontee .= '../';
				 }
				//---------------------------------------
				//Supprime 1er "/" de $path_allmystats_abs Important si $remontee = ""
				$path_allmystats_rel = substr($path_allmystats_abs, 1);
				$Fnm = $remontee.$path_allmystats_rel."cache/stats_".$site."_".$format_date_file_name."-".$suffixe.".php";
				
				//$time = time() - 30; //ajoute 30 seconde //date du fichier = + 30 secondes  la date actuelle 
				touch($Fnm); // modifie date du fichier sur la date actuelle
				//-----------------------------------------------------------------------------

	// -------------------------------------- Affichage -----------------------------------------------------------------------
	$show_footer = '<div align="center" '.$txt_style.'><a href="http://allmystats.wertronic.com" target="_blank">AllMyStats '.VERSION.'</a> Powered by <a href="http://www.wertronic.com" target="_blank">Wertronic</a></div><br />';
	$show_cumul_page = $show_footer;

	//###################################################################################################################
	//										NOUVEAU GRAPH PAR JOUR NOUVEAU
	//###################################################################################################################
if ($display_graph_by_day) {

	//Hauteur graph
	$height_graph = 180.00; // dans boucle pour plus de clart

	$total_nb_pages_visitees = "";
	$max_pages = "";
	$result = mysql_query("select visited_pages, sum(visited_pages) as total_visited_page from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY date");
	while($row = mysql_fetch_array($result)){ //while sur nb jour
		if($row['total_visited_page'] > $max_pages){
			$max_pages = $row['total_visited_page']; // Pour chaque jour
		}
		$total_nb_pages_visitees = $total_nb_pages_visitees + $row['total_visited_page'];
	}

	$result = mysql_query("select * from ".TABLE_UNIQUE_VISITOR." where date like '%".$mois."'");
	$total_nb_visiteurs = mysql_num_rows($result);

$graph_byday .= "
<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
  <tr>
    <td ".$td_style.">
      <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
        <tr>
          <th ".$table_title.">"
		  	.MSG_GRAPH_DAY_VISITORS_PAGES." (".MSG_EXCLUDED_BOTS.") - ".$mois."
		  </th>
          </tr>
        <tr>
          <td colspan=\"2\" ".$td_style.">
		  	<small>Total visiteurs = ".$total_nb_visiteurs."<br />
			Total pages visites = ".$total_nb_pages_visitees."</small>
            <table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
              <tr>
          		<td rowspan=\"2\" ".$td_style.">
					<b><span ".$page_view.">".MSG_VISITED_PAGES."</span><br />
					&amp; 
		  			<span ".$style_visits.">".MSG_VISITORS."</span></b>
		  		</td>";
				
				//Pour affichage echelle y
				if($max_pages != 0){
					echo $row['visited_pages']."<br>";
					$indice_echelle = 1; $hauteur = bcmul($indice_echelle, $height_graph, 2);
					if ($MaxHauteur_echelle <= $hauteur) { $MaxHauteur_echelle = $hauteur; $EchyMin = '0'; }
				} else { // pour ne pas afficher 0 si $max_pages = 0
					$EchyMin  = '';	
					$max_pages = '';
				}

$graph_byday .= "
		  	<td nowrap=\"nowrap\" valign=\"top\" ".$td_style.">".$max_pages."</td>
		  	<td rowspan=\"2\" valign=\"bottom\" ".$td_style."><img src=\"".$path_allmystats_abs."images/histo-v_black.gif\" height=\"".$MaxHauteur_echelle."\" width=\"1\" alt=\"y\" title=\"y\"/></td>";

			unset($val_jour);
			$result = mysql_query("select date, sum(visitors) as total_visitors_day, sum(visited_pages) as total_visited_page_day from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY date");
			while($row = mysql_fetch_array($result)){ //while sur nb jour

				$date_comp = $row['date'];
				$cpt_jour = substr($date_comp, 0, 2) + 0; // + 0 pour faire disparaitre les 0 devant 01, 02, 03 etc (aussi simple qu'une regex)

				$result_uniq_visits = mysql_query("select date from ".TABLE_UNIQUE_VISITOR." where date='".$row['date']."'");

				$val_jour[$cpt_jour][0] = mysql_num_rows($result_uniq_visits);
				$val_jour[$cpt_jour][1] = $row['total_visited_page_day'];

				$graph_byday .= "<td rowspan=\"2\" valign=\"bottom\" ".$td_style.">";
				if($max_pages != 0) {
					$indice = bcdiv($val_jour[$cpt_jour][1], $max_pages,2); $hauteur = bcmul($indice, $height_graph, 2);
				}
				$graph_byday .= "<img src=\"".$path_allmystats_abs."images/histo-v.gif\" height=\"".$hauteur."\" width=\"7\" alt=\"".$val_jour[$cpt_jour][1]."\" title=\"".$val_jour[$cpt_jour][1]."\"/>";

				if($max_pages!=0){
					$indice = bcdiv($val_jour[$cpt_jour][0], $max_pages, 2); $hauteur = bcmul($indice, $height_graph, 2);  
				}
				$graph_byday .=  "<img src=\"".$path_allmystats_abs."images/histo-vv.gif\" height=\"".$hauteur."\" width=\"7\" alt=\"".$val_jour[$cpt_jour][0]."\" title=\"".$val_jour[$cpt_jour][0]."\"/></td>";

			}

$graph_byday .= "
		  </tr>
		  <tr>
			 <td align=\"right\" valign=\"bottom\" ".$td_style.">".$EchyMin."</td>
		  </tr>
		  
              <tr>
                <td ".$td_style."><b>". MSG_GRAPH_DAY."</b></td>

 	    <td align=\"center\" ".$td_style.">&nbsp;</td><td align=\"center\" ".$td_style.">&nbsp;</td>"; // Pour echelle x
		
		//----------------- calcul jour du mois et week end pour echelle x ------------------------
		$jm = explode("/",$mois);
		$nbjourdumois = maxDaysInMonth($jm[0], $jm[1]);
		
		// Premier samedi du mois (6eme jour de la semaine) fonction get_first_day
		$premiersamedi =  strftime("%d", get_first_day(6, $jm[0], $jm[1])); 
		$weekend = "/";
		if ($premiersamedi == 7) { $weekend .= sprintf("%02d",1).'|'; } //Le 1er jour du mois est un dimanche
		for($i = $premiersamedi; $i <= $nbjourdumois; $i=$i+7){
			$week = $i;
			$week = $week+0;
			$weekend .= sprintf("%02d",$week).'|'; 
			$weekend .= sprintf("%02d",$week+1) .'|';
		}
		$weekend = substr($weekend, 0, strlen($weekend)-1); //supp last |
		$weekend .= "/";
		//------------------ Affichage echelle x -----------------
		for($i = 1; $i <= $nbjourdumois; $i++){
			$num = $i;
			if(!preg_match($weekend, sprintf("%02d", $num))) {	//$num+0 pour supprimer les 0 devant 01, 02 ,03 etc
		  		$graph_byday .=  "<td align=\"center\" ".$td_style.">". sprintf("%02d", $num)."</td>";
		  	} else {
		  		$graph_byday .= "<td align=\"center\" ".$td_style."><b><font color=\"#990000\">". sprintf("%02d", $num)."</font></b></td>";
			}
		}
		//---------------------------------------------------------------------------------------

$graph_byday .= "
						</tr>
					</table>
				</td></tr>
			</table>
		</td></tr>
	</table><br />";

		 $show_cumul_page .= $graph_byday;
		 $graph_byday ="";

	//--------------------------------------------------------------------------------------------
} // End if ($display_graph_by_day) {

	//############################################################################################
	//									KEYWORDS MONTHLY
	//############################################################################################	

	if ($display_keywords) {

		//Total different keywords
		$total_keywors = mysql_query("select COUNT(*) from ".TABLE_MONTHLY_KEYWORDS." where date='".$mois."' and keyword<>'TOTAL_VISITS'");
		$total_differents_keyword = mysql_fetch_row($total_keywors); 

		$show_cumul_page .= "
		<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
		  <tr>
			<td ".$td_style.">
			  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
				<tr>
				  <th ".$table_title.">Top".$display_top_keywords."<br />".MSG_REFERERS_AND_KEYWORDS.' '.$mois."<br /><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_KEYWORDS.": ".$total_differents_keyword[0]."</font></small></th>
				  </tr>
				<tr>
				  <td colspan=\"2\" ".$td_style.">
					<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
					  <tr>
						<th ".$th_style.">". MSG_REFERERS."</th>
						<th ".$th_style.">". MSG_KEYWORDS."</th>
						<th ".$th_style.">". MSG_VISITORS."</th>
					  </tr>";
		// referer (unique) tri par keyword='TOTAL_VISITS'
		$referer = mysql_query("select host_referer, keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where date='".$mois."' and keyword='TOTAL_VISITS'");
		unset($Tab_referer);
		unset($tri_Tab_aff_ref);

		while($row = mysql_fetch_array($referer)){
			$Tab_referer[] = $row['host_referer'];
		}

		//lecture keywords, nb_item, Nb different keywords / referer
		for($i = 0; $i < count($Tab_referer); $i++){ 
			$result = mysql_query("select keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".$Tab_referer[$i]."' and date='".$mois."' order by nb_item DESC");
			$nb_keywords_diff = mysql_num_rows($result); //Nb different keywords
			while($row = mysql_fetch_array($result)){
				if($row['keyword']=='TOTAL_VISITS') {
					$tri_Tab_aff_ref[] = array($row['nb_item'], $Tab_referer[$i], $row['keyword'], $nb_keywords_diff); //dans ce sens car on trie sur nb visites
				} 
			}
		}
		@array_multisort($tri_Tab_aff_ref,SORT_DESC);
		for($i = 0; $i < count($tri_Tab_aff_ref); $i++){
			$distinct_keyword_count = intval($tri_Tab_aff_ref[$i][3])-1; // -1 car TOTAL_VISITS est compt
			$result = mysql_query("select keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".trim($tri_Tab_aff_ref[$i][1])."' and date='".$mois."' ORDER BY nb_item DESC, keyword ASC LIMIT ".$display_top_keywords."");

			//-----------------------------
			//Longueur Affichage Referer
			$lenmax=35;
			if (strlen($tri_Tab_aff_ref[$i][1])>$lenmax) {
				$chaine1=substr($tri_Tab_aff_ref[$i][1], 0, $lenmax);
				$chaine2=substr($tri_Tab_aff_ref[$i][1], $lenmax);
				$tri_Tab_aff_ref[$i][1] = $chaine1."<br />".$chaine2;
			}
			//-----------------------------

			$show_cumul_page .= "
			<tr>
			  <td align=\"left\" valign=\"top\" ".$td_style.">
			  	".$tri_Tab_aff_ref[$i][1]."
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">";
			    if ($distinct_keyword_count<>0) {
					$show_cumul_page .= "<span>Diffrents: ". $distinct_keyword_count ."</span><br />";
				} else {
					$show_cumul_page .= "&nbsp;";
				}
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['keyword']."</font></span><br />"; 
					}
				}
			$show_cumul_page .= "
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
			    Total: ".$tri_Tab_aff_ref[$i][0]."<br />";
				
				@mysql_data_seek($result, 0); // reset($result);
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['nb_item']."</font></span><br />";
					}
				}

			$show_cumul_page .= "
			  </td>
			 </tr>";
		}

		$show_cumul_page .= "</table></td></tr>
			  </table></td></tr></table><br />" ;

	unset($Tab_referer);
	unset($tri_Tab_aff_ref);

	} // End if ($display_keywords ) {


	//############################################################################################
	//								KEYWORDS BY DAY
	//############################################################################################	

	if ($display_keywords_by_day) {
		
		$day = date('d/m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
		
		//Total different keywords
		$total_keywors = mysql_query("select COUNT(*) from ".TABLE_DAYS_KEYWORDS." where date='".$day."' and keyword<>'TOTAL_VISITS'");
		$total_differents_keyword = mysql_fetch_row($total_keywors); 
	
		$show_cumul_page .= "
		<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
		  <tr>
			<td ".$td_style.">
			  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
				<tr>
				  <th ".$table_title.">Top".$display_top_keywords."<br />".MSG_REFERERS_AND_KEYWORDS.' '.$day."<br /><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_KEYWORDS_DAY.": ".$total_differents_keyword[0]."</font></small></th>
				  </tr>
				<tr>
				  <td colspan='2' ".$td_style.">
					<table border='1' cellpadding='2' cellspacing='0' ".$table_data.">
					  <tr>
						<th ".$th_style.">".MSG_REFERERS."</th>
						<th ".$th_style.">".MSG_KEYWORDS."</th>
						<th ".$th_style.">".MSG_VISITORS."</th>
					  </tr>";
		// referer (unique) tri par keyword='TOTAL_VISITS'
		$referer = mysql_query("select host_referer, keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where date='".$day."' and keyword='TOTAL_VISITS'");
		unset($Tab_referer);
		unset($tri_Tab_aff_ref);

		while($row = mysql_fetch_array($referer)){
			$Tab_referer[] = $row['host_referer'];
		}

		//lecture keywords, nb_item, Nb different keywords / referer
		for($i = 0; $i < count($Tab_referer); $i++){ 
			$result = mysql_query("select keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".$Tab_referer[$i]."' and date='".$day."' order by nb_item DESC");
			$nb_keywords_diff = mysql_num_rows($result); //Nb different keywords
			while($row = mysql_fetch_array($result)){
				if($row['keyword']=='TOTAL_VISITS') {
					$tri_Tab_aff_ref[] = array($row['nb_item'], $Tab_referer[$i], $row['keyword'], $nb_keywords_diff); //dans ce sens car on trie sur nb visites
				} 
			}
		}
		@array_multisort($tri_Tab_aff_ref,SORT_DESC);
		for($i = 0; $i < count($tri_Tab_aff_ref); $i++){
			$distinct_keyword_count = intval($tri_Tab_aff_ref[$i][3])-1; // -1 car TOTAL_VISITS est compt
			$result = mysql_query("select keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".trim($tri_Tab_aff_ref[$i][1])."' and date='".$day."' ORDER BY nb_item DESC, keyword ASC LIMIT ".$display_top_keywords."");

			//-----------------------------
			//Longueur Affichage Referer
			$lenmax=35;
			if (strlen($tri_Tab_aff_ref[$i][1])>$lenmax) {
				$chaine1 = substr($tri_Tab_aff_ref[$i][1], 0, $lenmax);
				$chaine2 = substr($tri_Tab_aff_ref[$i][1], $lenmax);
				$tri_Tab_aff_ref[$i][1] = $chaine1."<br />".$chaine2;
			}
			//-----------------------------

			$show_cumul_page .= "
			<tr>
			  <td align=\"left\" valign=\"top\" ".$td_style.">
			  	".$tri_Tab_aff_ref[$i][1]."
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">";
			    if ($distinct_keyword_count<>0) {
					$show_cumul_page .= "<span>Diffrents: ". $distinct_keyword_count ."</span><br>";
				} else {
					$show_cumul_page .= "&nbsp;";
				}

				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['keyword']."</font></span><br />"; 
					}
				}
			$show_cumul_page .= "
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
			    Total: ".$tri_Tab_aff_ref[$i][0]."<br />";
				
				@mysql_data_seek($result, 0); // reset($result);
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['nb_item']."</font></span><br />";
					}
				}

			$show_cumul_page .= "
			  </td>
			 </tr>";
		}

		$show_cumul_page .= "</table></td></tr>
			  </table></td></tr></table><br />" ;

	unset($Tab_referer);
	unset($tri_Tab_aff_ref);

	} // End if ($display_keywords_by_day ) {


	//############################################################################################
	//						NOUVEAU Pages visites NOUVEAU<br>
	//############################################################################################
if ($display_page_view) {
		
	$result = mysql_query("select count(*) as nb_diff_pages, sum(visited_pages) as total_pages from ".TABLE_DAYS_PAGES." where date like '%".$mois."'");
	$row = mysql_fetch_array($result);
	$pages_cumul = $row['total_pages']; // Total Pages

	$result = mysql_query("select pages_name, sum(visitors) as total_visitors, sum(visited_pages) as total_pages from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY pages_name order by total_pages DESC, pages_name ASC");
	$differents_pages = mysql_num_rows($result); // Pages diffrentes
		
	$show_cumul_page .= "
	<table align=\"center\" cellpadding=\"1\" cellspacing='0' ".$table_border.">
	  <tr>
		<td ".$td_style.">
		  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
			<tr>
			  <th ".$table_title.">". MSG_VISITED_PAGES." (".MSG_EXCLUDED_BOTS.")".$mois."<br><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_PAGES.": ".$differents_pages."</small></font></th>
			  </tr>
	
			<tr>
			  <td colspan=\"2\" ".$td_style.">
				<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
				  <tr>
					<th ".$th_style.">".MSG_PAGE."</th>
					<th ".$th_style.">".MSG_VISITORS."</th>
					<th ".$th_style.">".MSG_VISITED_PAGES."</th>
					<th ".$th_style.">".MSG_PAGES_PERCENTAGE."</th>
				  </tr>";
	
				while($row=mysql_fetch_array($result)){
					$nb = $row['total_pages']*100; 
					if($pages_cumul != 0){
						$percents = bcdiv($nb, intval($pages_cumul), 2);
				}

				$show_cumul_page .= "<tr><td ".$th_style.">".utf8_decode($row['pages_name'])."</td><td align=\"center\" ".$th_style.">".$row['total_visitors']."</td><td align=\"center\" ".$th_style.">".$row['total_pages']."</td><td align=\"center\" ".$th_style.">".$percents."%</td></tr>";
			}
	
		$show_cumul_page .= "
		</table></td></tr></table></td></tr></table><br />";

	} // End de if ($display_page_view) {	
	

			//############################################################################################
			//						 NOUVEAU ORIGINE GEO MONTH NOUVEAU
			//############################################################################################
		if ($display_org_geo) {
				
			$result = mysql_query("select count(country) as visitors_by_country, sum(visits) as pages_by_country, country from ".TABLE_UNIQUE_VISITOR." where date like '%".$mois."' GROUP BY country ORDER BY pages_by_country DESC");
			$total_differents_countries = mysql_num_rows($result);
				
			$row = mysql_fetch_array($result);
			$indice = @bcdiv(1, ($row['pages_by_country']/300), 2); //proportion en rapport au plus grand nb de pages visits
		
		$show_cumul_page .= "
			<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
			  <tr>
				<td ".$td_style.">
				  <table align=\"center\" cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
					<tr>
					  <th ".$table_title.">".MSG_TITLE_ORG_GEO." (".MSG_EXCLUDED_BOTS.")<br><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_COUNTRIES.": ".$total_differents_countries."</font><small></TH>
					</tr>
					<tr>
					  <td colspan=\"2\" ".$td_style.">
						<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
						  <tr>
							<th ".$th_style.">".MSG_COUNTRY."</th>
							<th ".$th_style.">".MSG_NB_VISITORS."</th>
							<th ".$th_style.">".MSG_VISITED_PAGES."</th>
						  </tr>";
		
					mysql_data_seek($result, 0); //reset($result) to 0;
					while($row = mysql_fetch_array($result)){
						if ($row['country'] == '') { 
							$Country = MSG_ORIGIN_UNKNOWN;
						} else {
							$Country = $row['country'];
						}
						
		$show_cumul_page .= "<tr>
						<td nowrap=\"nowrap\" ".$td_style.">  
							<b>".$Country."</b>
						</td>
						<td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
							<img src=\"".$path_allmystats_abs."images/histo-h.gif\" width=\""; 
							$hauteur = bcmul($row['visitors_by_country'] , $indice, 2);  
		$show_cumul_page .= $hauteur . "\" height=\"8\" alt=\"".$row['visitors_by_country']."\" title=\"".$row['visitors_by_country']."\">".$row['visitors_by_country'].
						"</td>
						<td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
							<img src=\"".$path_allmystats_abs."images/histo-h.gif\" width=\"";
							$hauteur = bcmul($row['pages_by_country'], $indice, 2);  
		$show_cumul_page .= $hauteur."\" height=\"8\" alt=\"".$row['pages_by_country']."\" title=\"".$row['pages_by_country']."\">".$row['pages_by_country'].
						"</td>";	
					}
		
		
		$show_cumul_page .= '</table></td></tr></table></td></tr></table><br />';
		
		
		} // End if ($display_org_geo) {
				
	$dislpay_button_tool_bots = "false"; //Important "false" entre guillemets car affiche le bouton si  $dislpay_button_tool_bots = "";
		?>
		<table width="90%" border="0" align="center">
		  <tr>
			<td align="center"><?  
				$when_date = $mois; // date d/m/Y or m/Y
				include(FILENAME_DISPLAY_OS_BROWSER);	
				$show_cumul_page .= $show_page_os_nav_robots;
				?>
			</td>
		  </tr>
		</table>
		<?
	
		//###############################################################################################
		//########################################## AFFICHAGE ##########################################
		
			echo $show_cumul_page;	// Affichage des tableaux
			message($msg , "");		//efface le message Patientez
	
			//--------- Footer -------------------
			echo $show_footer ;
			//------------------------------------					

		//###############################################################################################	
		//###############################################################################################
		
	########################################## Mise en cache du mois encours actuel #######################################
	
			$mois_actuelle = date('m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			$mois_Visualise = $mois;
		
			$Mois_Annee_visualise = explode("/", $mois_Visualise);
			$mois_visualise = $Mois_Annee_visualise[0]; // mois
			$annee_visualise = $Mois_Annee_visualise[1]; //anne
			
			$Mois_Annee_actuelle = explode("/", $mois_actuelle);
			$mois_actuelle = $Mois_Annee_actuelle[0];
			$annee_actuelle = $Mois_Annee_actuelle[1];
	
			if ($action_cache_mois_in || isset($archive_encours) ) { //on met en cache
			
				if (!is_dir($path_allmystats."cache")) {
					mkdir ($path_allmystats."cache");
				}

				//--------------------------------------------------------------------------------------
				//Ne sert pas pour ici (stats_in) mais est pour l'instant ncessaire pour les pages mises en cache avec FILENAME_MONTHLY_ARCHIVES_EDIT
				if (!is_dir($path_allmystats."cache/images")) {
					mkdir ($path_allmystats."cache/images");
				}
				if (!file_exists("cache/images/histo-v_black.gif")) {
					copy($path_allmystats."images/histo-v_black.gif", $path_allmystats."cache/images/histo-v_black.gif");
				}
				if (!file_exists("cache/images/histo-v.gif")) {
					copy($path_allmystats."images/histo-v.gif", $path_allmystats."cache/images/histo-v.gif");
				}
				if (!file_exists("cache/images/histo-vv.gif")) {
					copy($path_allmystats."images/histo-vv.gif", $path_allmystats."cache/images/histo-vv.gif");
				}
				if (!file_exists("cache/images/histo-h.gif")) {
					copy($path_allmystats."images/histo-h.gif", $path_allmystats."cache/images/histo-h.gif");
				}
				//--------------------------------------------------------------------------------------

				$Mois_Annee = explode("/", $mois_Visualise);
				$format_date_file_name = $Mois_Annee[1].'-'.$Mois_Annee[0];
				
				 //---------- Pour contourner le pb open_basedir restriction in effect avec fopen ----------------
				 $nbSlashes = substr_count($_SERVER['SCRIPT_NAME'], '/'); // on compte le nombre total de slashes contenu dans le lien relatif du fichier courant
				 $nbSlashes --; // on ne compte pas le slash de la racine (plac au dbut du lien relatif)
				 $remontee = ''; // on initialise la remonte dans l'arborescence
				 for($i = 0; $i < $nbSlashes; $i++) {
					 $remontee .= '../';
				 }
				//------------------------------------------------------------------------------------------------
				//Supprime 1er "/" de $path_allmystats_abs Important si $remontee = ""
				substr('abcdef', 1);
				$path_allmystats_rel = substr($path_allmystats_abs, 1);
				$Fnm = $remontee.$path_allmystats_rel."cache/stats_".$site."_".$format_date_file_name."-".$suffixe.".php";

				if (!$inF = @fopen($Fnm,"w")){
					echo "Erreur create file<br />";
				}

				if ($html_body) {
					$page_html = 
					'<?
					if( ($user_login!=$_SESSION["userlogin"] || $passwd!=$_SESSION["userpass"]) && $public==false)	{
						echo "<br /><br /><center><strong>Vous n\'tes pas autoris  visiter cette page</strong></center><br />";
						exit;
					}
					?>
					
						<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 						"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
						<html xmlns="http://www.w3.org/1999/xhtml">
						<head>
						<title>AllMyStats - '. $site.' - '.$format_date_file_name.'</title>
				
						<style type="text/css">
						<!--
						.StyleBleuClair {color: #006DB7}
						.NoirMoyen {font-size: 120%; color: #333333; }
						.plop {
						   text-decoration: blink;
						}
						.Noirclair {
							color: #2D2D2D;
							font-weight: bold;
						}
						.Style41 {color: #003C64; font-size: 110%; }
						.Style63 {color: #009900}
						.Style65 {color: #003C64; font-size: 110%; font-weight: bold; }
						.Style61 {color: #006600;
							font-weight: bold;
						}
						.Style56 {font-size: 14px;
							color: #002779;
							font-weight: bold;
						}
						-->
						</style>
						</head>
						<body>
							<table align="center" width="100%" border="0">
								<tr>
									<td align="center" '.$txt_title.'>Statistiques site: '.$site." - Mois: ".$mois_Visualise.'<br /><br /></td>
								</tr>
								<tr>
									<td align="center">'.$show_cumul_page . $show_page_os_nav_robots.$show_footer.'</td>
								</tr>
							</table>
						</body></html>';
				} else {
					$page_html = 
						'<?
						if( ($user_login!=$_SESSION["userlogin"] || $passwd!=$_SESSION["userpass"]) && $public==false)	{
							echo "<br /><br /><center><strong>Vous n\'tes pas autoris  visiter cette page</center></strong><br />";
							exit;
						}
						?>
				
						<table width="100%" border="0" align="center">
							<tr>
								<td align="center" '.$txt_title.'>Statistiques site: '.$site." - Mois: ".$mois_Visualise.'<br /><br /></td>
							</tr>
							<tr>
								<td align="center">'.$show_cumul_page . $show_page_os_nav_robots.$show_footer.'</td>
							</tr>
							</table>';
				}

				if(!@fwrite($inF,$page_html)){
					echo "Erreur write file<br />";
				}

				if(!@fclose($inF)){
					echo "Erreur close file";
				}

			} //End if ($action_cache_mois_in || isset($archive_encours) )

} // End if ($action_cache_mois_in) {

//-------------------------------------------------------------------------------------------
//#################################################################################################
//										Functions
//#################################################################################################

function CompareValeurs($val1, $val2) {
	if ($val2[1] == $val1[1])
		return(strcmp($val1[0],$val2[0]));
	else
		return($val2[1] - $val1[1]);
}

function msg_temporaire ($temp_msg) {
 	flush();
 	echo $temp_msg; ?>
	<script type="text/javascript">
	document.getElementById("cache").style.visibility = "visible";
	</script><?
 	flush();
}
 
function message($msg, $title){ ?> 
	<script type="text/javascript">
 		document.getElementById("cache").style.visibility = "hidden";
	</script><?php
}

?>
