<?php
/*
 -------------------------------------------------------------------------
 AllMyStats V1.56 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
*/

############################################# Functions ######################################################
//TODO rep functions car existe aussi dans FILENAME_MONTHLY_ARCHIVES_EDIT, stats_in.php, histomaois.php
/**
* Fonction retournant le nombre de jours dans un mois.
* @param integer $month Mois de 1  12
* @param integer $year Anne
* @return integer Nombre de jours
*/
function maxDaysInMonth($month, $year)
{
  $days = cal_days_in_month(CAL_GREGORIAN, $month, $year);
  return $days;
}

  /**
   *
   *  Gets the first weekday of that month and year
   *
   *  @param  int   The day of the week (0 = sunday, 1 = monday ... , 6 = saturday)
   *  @param  int   The month (if false use the current month)
   *  @param  int   The year (if false use the current year)
   *
   *  @return int   The timestamp of the first day of that month
   *
   **/ 
  function get_first_day($day_number=1, $month=false, $year=false)
  {
    $month  = ($month === false) ? strftime("%m"): $month;
    $year   = ($year === false) ? strftime("%Y"): $year;
   
    $first_day = 1 + ((7+$day_number - strftime("%w", mktime(0,0,0,$month, 1, $year)))%7);
 
    return mktime(0,0,0,$month, $first_day, $year);
  }

##############################################################################################################

?>
