<?
/*
 -------------------------------------------------------------------------
 AllMyStats V1.56 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
*/

// ----------------------------------------------------------------------------
// Extraction des mots cls quand les rfrants sont des moteurs de recherche
// ----------------------------------------------------------------------------
/*
# Liste originale. Quelques variables modifies pour coller  la ralit actuelle
yahoo.com p=
altavista.com q=
google.com q=
lycos.com query=
hotbot.com query=
msn.com q=
webcrawler searchText= N'est plus OK
excite q=
recherche.netscape.fr query=
alltheweb.com q=

# Moteurs franais ajouts.
google.fr q=
vachercher.lycos.fr query=
msn.fr q=
voila.fr rdata==
rechercher.aliceadsl.fr qs=
recherche.aol.fr q=
www.aolrecherche.aol.fr query=
search.free.fr qs=
www.seek.fr qry_str=
www.chello.fr q1=

# Autres moteurs (annuaires) ajouts.
looksmart.com key=
search.dmoz.org search=

*/

function MotsCles($ref, $ref_host) {

  $motscles = "";
  
  $url   = parse_url( $ref );
  $query = $url["query"];
  $host  = $url["host"];
  
  parse_str($query);

  //Pour les adwords l'url est trouve car dans visiteur.php est ajout au referer 
  //$Referer = urldecode($Url_syndication[0]). '?googlesyndication=1' ou '&googlesyndication=1';
  if ($googlesyndication==1) {
  	$motscles = $ref;
  }

  if ($host == 'fr.dir.yahoo.com') {
	$motscles = '['.trim(utf8_decode(strtolower($p))).']';
	$ref_host = 'Yahoo !';

  } elseif (strstr($host,'search.yahoo') <> '' && $p) {
	$motscles = '['.trim(utf8_decode(strtolower($p))).']';
	$ref_host = 'Yahoo !';

  } elseif ($host == 'search.voila.com' || $host == 'search.voila.fr' || $host == 'search.ke.voila.fr') {
	$motscles = '['.trim(utf8_decode(strtolower($rdata))).']';
	$ref_host = 'Voila';

  } elseif (strstr($host,'images.google') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'Google images';

  } elseif (strstr($host,'google') <> '' && $q || $as_q) { //as_q vu pour la 1ere fois le 01-09-2009
	if ($q) { $motscles = '['.trim(utf8_decode(strtolower($q))).']'; }
	if ($as_q) { $motscles = '['.trim(utf8_decode(strtolower($as_q))).']'; }

	$ref_host = 'Google';

  } elseif ((strstr($host,'216.239.59.104') <> '' || strstr($host,'209.85.135.104') <> ''|| strstr($host,'209.85.129.104') <> '') && $q ) {
	$CacheMot = explode( '/',utf8_decode($q));
	$motscles = 'Google cache['.trim($CacheMot[sizeof($CacheMot)-1]).']';
	$ref_host = 'Google';

  } elseif (strstr($host,'search.live') <> '' || strstr($host,'search.msn') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'MSN';

  } elseif (strstr($host,'excite') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'Excite';

  } elseif (strstr($host,'webring') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($ring))).']';
	$ref_host = 'ring';

  } elseif (strstr($host,'dada.net') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'ring';

  } elseif (strstr($host,'altavista') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'AltaVista';

  } elseif (strstr($host,"recherche.aol.fr") <> '' || strstr($host,"search.hp.my.aol") <> '' || strstr($host,"search.aol.com") <> '') { // pour www.aolrecherche.aol.fr et www.recherche.aol.fr
	if ($q <>'') {
		$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	} else {
		$motscles = '['.trim(utf8_decode(strtolower($query))).']';
	}
	$ref_host = 'AOL recherche';
	
  } elseif (strstr($host,"rechercher.aliceadsl.fr") <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($qs))).']';
	$ref_host = 'Aliceadsl (Tiscali)';

  } elseif (strstr($host,'vachercher.lycos') <> '' || strstr($host,'www.lycos.fr') <> '') {
	$motscles = '['.trim(utf8_decode(strtolower($query))).']';
	$ref_host = 'Lycos';
  
  } elseif ($host == 'hotbot.lycos.com') {
	$motscles = '['.trim(utf8_decode(strtolower($MT))).']';
	$ref_host = 'Lycos';

  } elseif (strstr($host,'search.free') <> '' && $q) { // Mais pas tjrs  http://search.free.fr/google.pl?next=/search?q= (avant c'tait $qs)
	$motscles = '['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'Free';

  } elseif (strstr($host,'seek') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($qry_str))).']'; // Si pas espace avant [ --> ne marche pas ???
	$ref_host = 'Seek';

  } elseif (strstr($host,'www.chello.fr') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q1))).']'; 
	$ref_host = 'chello.fr';

  } elseif (strstr($host,'search.sweetim') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'Sweetim';

  } elseif (strstr($host,'pagebull') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($qIn))).']';
	$ref_host = 'Pagebull';

  } elseif (strstr($host,'picsearch') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']';
	$ref_host = 'Picsearch';

  } elseif (strstr($host,'recherche.hit-parade.com') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($p7))).']'; 
	$ref_host = 'recherche.hit-parade.com';

  } elseif (strstr($host,'www.veosearch.com') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'Veosearch.com';

  } elseif (strstr($host,'search15.conduit.com') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search15.conduit.com';

  } elseif (strstr($host,'www.toile.com') <> '') {
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'www.toile.com';

  } elseif (strstr($host,'www.bing.com') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'www.bing.com';

  } elseif (strstr($host,'lo.st') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($x_query))).']'; 
	$ref_host = 'lo.st';

  } elseif (strstr($host,'exalead') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'exalead';

  } elseif (strstr($host,'search.conduit.com') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search.conduit.com';

  } elseif (strstr($host,'search.babylon.com') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search.babylon.com';

  } elseif (strstr($host,'hooseek.com') <> '') { 
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'hooseek.com';

  } elseif (strstr($host,'search.twitter.com') <> '') {    // No OK moteur de recherche interne
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search.twitter.com';

  } elseif (strstr($host,'search.incredimail.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search.incredimail.com';

  } elseif (strstr($host,'ask.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'ask.com';

  } elseif (strstr($host,'yougoo.fr') <> '') {  //Depend de Yahoo
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'yougoo.fr';

  } elseif (strstr($host,'searchqu.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'searchqu.com';

  } elseif (strstr($host,'fastbrowsersearch.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'fastbrowsersearch.com';

  } elseif (strstr($host,'search.bluewin.ch') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($query))).']'; 
	$ref_host = 'search.bluewin.ch';

  } elseif (strstr($host,'search.netscape.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'search.netscape.com ';

  } elseif (strstr($host,'alltheweb.com') <> '') {  
	$motscles = ' ['.trim(utf8_decode(strtolower($q))).']'; 
	$ref_host = 'alltheweb';

  }
  
  
  if ($motscles != "") {
    return stripslashes(htmlentities($motscles));
  }
	
	
} // End function
?>

